//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef CITYOCCUPATIONDIALOG_H
#define CITYOCCUPATIONDIALOG_H

#include <pgwindow.h>
#include <pgeventobject.h>

class PG_Button;
class PG_Label;
class Stack;
class City;

class CityOccupationDialog : public PG_EventObject, public PG_Window
{ 
	public:
		// CREATORS
		CityOccupationDialog(City* city);
		~CityOccupationDialog();

		// CALLBACKS
		PARAGUI_CALLBACK(b_occupyClicked);
		PARAGUI_CALLBACK(b_pillageClicked);
		PARAGUI_CALLBACK(b_razeClicked);

	private:
		// WIDGETS
		PG_Button* d_b_occupy;
		PG_Button* d_b_pillage;
		PG_Button* d_b_raze;
		PG_Label* d_l_msg;
        SDL_Surface* d_background;

		// DATA
		City* d_city;
};

#endif

// End of file
