//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef FIGHTDIALOG_H
#define FIGHTDIALOG_H

#include <vector>
#include <pgeventobject.h>
#include <pgthemewidget.h>
#include <pglabel.h>
#include "fight.h"

class Stack;

class FightDialog : public PG_EventObject, public PG_ThemeWidget
{ 
        public:
        // CREATORS
        FightDialog(std::vector<Stack*>& attacker,
            std::vector<Stack*>& defender,
            PG_Widget* parent,
            bool def_bonus = true);
		//shortcut
		FightDialog(Stack* attacker, Stack* defender, PG_Widget* parent,
            bool def_bonus = true);
		~FightDialog();

		// MANIPULATORS
		void battle();

        // ACCESSORS
		Fight::RESULT getResult() const {return d_result;}

        private:
		void initScreen();
		
		// EVENT HANDLERS
		void eventDraw(SDL_Surface* surface, const PG_Rect& rect);
		void drawArmy (SDL_Surface* surface, int x, int y, Army* unit);

		// DATA
		std::vector<Stack*> d_attacker;
		std::vector<Stack*> d_defender;
		bool d_def_bonus;
		int d_turn;
		PG_Label* d_l_turn;
		Fight::RESULT d_result;
		static const int ROUND_DELAY = 300;
};

#endif // FIGHTDIALOG_H
