//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef MAPCONFDIALOG_H
#define MAPCONFDIALOG_H

#include <string>
#include <sigc++/sigc++.h>
#include <pgwindow.h>
#include <pgeventobject.h>
#include "GameScenario.h"

class PG_Slider;

class TerrainConfig : public PG_EventObject, public SigC::Object
{
    public:
        // CREATORS
        TerrainConfig(PG_Widget* parent, PG_Rect rect, char* name, int min, int max, int pos);
        ~TerrainConfig();

        // MANIPULATORS
        void hide();
        void show();

        // ACCESSORS
        int getValue() {return d_value;}
        
        // CALLBACKS
        PARAGUI_CALLBACK(slide);

    private:
        PG_Label* d_l_name;
        PG_Label* d_l_value;
        PG_Slider* d_slider;
        PG_Button* d_button;
        int d_value;
};

#endif

// End of file
