//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "maptile.h"
#include <stdlib.h>
#include <iostream>
#include "TileSet.h"

Maptile::Maptile(TileSet* tileSet, int x, int y, int type)
{
    d_tileSet = tileSet;
	d_type = type;
	d_moves = d_tileSet->getTile(type)->getMoves();
	d_building = NONE;
    d_smoothed = false;
}

Maptile::~Maptile()
{
}

void Maptile::setCorners(int c1, int c2, int c3, int c4)
{
    d_corner[0] = c1;
    d_corner[1] = c2;
    d_corner[2] = c3;
    d_corner[3] = c4;
    d_smoothed = true;
}

unsigned int Maptile::getMaptileType()
{
    return d_tileSet->getTile(d_type)->getType();
}


SDL_Color Maptile::getColor()
{
    return d_tileSet->getTile(d_type)->getColor();
}

void Maptile::printDebugInfo()
{
	std::cerr << "MAPTILE: type = " << (int)d_type << std::endl;
	std::cerr << "MAPTILE: building = " << (int)d_building << std::endl;
}	

// End of file
