//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef RUIN_H
#define RUIN_H

#include <string>
#include "Location.h"
#include "stack.h"
#include <sigc++/object_slot.h>

class Stack;

class Ruin : public Location, public SigC::Object
{
	public:
		Ruin(PG_Point pos, std::string name = "", Stack* owner = 0,
			bool searched = false);
		Ruin(const Ruin&);
        Ruin(XML_Helper* helper);
		~Ruin();

		// MANIPULATORS
		void setSearched(bool searched) {d_searched = searched;}
		void setOccupant(Stack* occupant) {d_occupant = occupant;}

		// ACCESSORS
		bool isSearched() const {return d_searched;}
		Stack* getOccupant() {return d_occupant;}
		unsigned int getId() {return d_id;}

		bool save(XML_Helper* helper);
        bool load(std::string tag, XML_Helper* helper);

	private:
		// DATA
		bool d_searched;	// has ruin already been searched for treasure?
		Stack* d_occupant;
		unsigned int d_id;
};

#endif // RUIN_H

