//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "ruinlist.h"

//#define debug(x) {cerr<<__FILE__<<": "<<__LINE__<<": "<<x<<endl;}
#define debug(x)

Ruinlist* Ruinlist::s_instance = 0;

Ruinlist* Ruinlist::getInstance()
{
    if (s_instance == 0)
        s_instance = new Ruinlist();

    return s_instance;
}

Ruinlist* Ruinlist::getInstance(XML_Helper* helper)
{
    if (s_instance)
        deleteInstance();

    s_instance = new Ruinlist(helper);
    return s_instance;
}

void Ruinlist::deleteInstance()
{
    if (s_instance)
        delete s_instance;

    s_instance = 0;
}

Ruinlist::Ruinlist()
{
}

Ruinlist::Ruinlist(XML_Helper* helper)
{
    //the only argument up to now is size, which we ignore here
    helper->registerTag("ruin", SigC::slot((*this), &Ruinlist::load));
}

bool Ruinlist::save(XML_Helper* helper)
{
	bool retval = true;

	retval &= helper->openTag("ruinlist");
	retval &= helper->saveData("size", size());

	for (iterator it = begin(); it != end(); it++)
		retval &= it->save(helper);
	
	retval &= helper->closeTag();

	return retval;
}

bool Ruinlist::load(std::string tag, XML_Helper* helper)
{
    if (tag != "ruin")
    //??? shouldn't happen, but one never knows...
        return false;

    Ruin r(helper);
    push_front(r);

    //now we need to set up a callback for the stak residing in the ruin
    helper->registerTag("stack", SigC::slot((*begin()), &Ruin::load));

    return true;
}
